package com.example.chat2weeks;

import java.util.ArrayList;
import java.util.Random;

import com.example.chat2weeks.Model.MessageChat2Weeks;
import com.example.chat2weeks.adapter.MessageAdapter;
import com.example.chat2weeks.tab.ChatFragment;
import com.example.chat2weeks.tab.ContactFragment;


import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Message;
import android.app.Activity;
import android.app.ListActivity;
import android.content.Intent;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.EditText;

public class ChatActivity extends ListActivity {
	
	public static final String DEBUG_CHATACTIVITY = "com.example.chat2weeks.ChatActivity";
	ArrayList<MessageChat2Weeks> messages;
	MessageAdapter adapter;
	EditText text;
	static Random rand = new Random();	
	static String sender;
	private int type_of_sender = 0;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_chat);
		
		/* get Data Here from intent */
		Intent passData= getIntent();
		if(passData != null){
			Log.d(DEBUG_CHATACTIVITY, "Mengambil data dari intent");
			// check dari chatting atau contact list
			type_of_sender = passData.getIntExtra(DashboardActivity.TYPE_FRAGMENT, 0);
			switch (type_of_sender) {
			case ContactFragment.TYPE_CONTACTFRAGMENT:
				sender = passData.getStringExtra(ContactFragment.STRING_CONTACTFRAGMENT);
				break;
			case ChatFragment.TYPE_CHATFRAGMENT:
				sender = passData.getStringExtra(ChatFragment.STRING_CHATFRAGMENT);
				break;
			default:
				Log.d(DEBUG_CHATACTIVITY, "Tidak ada data dari Tab Fragment");
				sender =  MessageAdapter.DummyData.sender[rand.nextInt( MessageAdapter.DummyData.sender.length-1)];
				break;
			}
		}
		
		text = (EditText) this.findViewById(R.id.text);
		this.setTitle(sender);
		messages = new ArrayList<MessageChat2Weeks>();

		messages.add(new MessageChat2Weeks("Hello", false));
		messages.add(new MessageChat2Weeks("Hi!", true));
		messages.add(new MessageChat2Weeks("Wassup??", false));
		messages.add(new MessageChat2Weeks("nothing much, working on speech bubbles.", true));
		messages.add(new MessageChat2Weeks("you say!", true));
		messages.add(new MessageChat2Weeks("oh thats great. how are you showing them", false));
		

		adapter = new MessageAdapter(this, messages);
		setListAdapter(adapter);
		addNewMessage(new MessageChat2Weeks("mmm, well, using 9 patches png to show them.", true));

	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.chat, menu);
		return true;
	}

	public void sendMessage(View v)
	{
		String newMessage = text.getText().toString().trim(); 
		if(newMessage.length() > 0)
		{
			text.setText("");
			addNewMessage(new MessageChat2Weeks(newMessage, true));
			new SendMessage().execute();
		}
	}
	private class SendMessage extends AsyncTask<Void, String, String>
	{
		@Override
		protected String doInBackground(Void... params) {
			try {
				Thread.sleep(2000); //simulate a network call
			}catch (InterruptedException e) {
				e.printStackTrace();
			}
			
			this.publishProgress(String.format("%s started writing", sender));
			try {
				Thread.sleep(2000); //simulate a network call
			}catch (InterruptedException e) {
				e.printStackTrace();
			}
			this.publishProgress(String.format("%s has entered text", sender));
			try {
				Thread.sleep(3000);//simulate a network call
			}catch (InterruptedException e) {
				e.printStackTrace();
			}
			
			
			return MessageAdapter.DummyData.messages[rand.nextInt(MessageAdapter.DummyData.messages.length-1)];
			
			
		}
		@Override
		public void onProgressUpdate(String... v) {
			
			if(messages.get(messages.size()-1).isStatusMessage)//check wether we have already added a status message
			{
				messages.get(messages.size()-1).setMessage(v[0]); //update the status for that
				adapter.notifyDataSetChanged(); 
				getListView().setSelection(messages.size()-1);
			}
			else{
				addNewMessage(new MessageChat2Weeks(true,v[0])); //add new message, if there is no existing status message
			}
		}
		@Override
		protected void onPostExecute(String text) {
			if(messages.get(messages.size()-1).isStatusMessage)//check if there is any status message, now remove it.
			{
				messages.remove(messages.size()-1);
			}
			
			addNewMessage(new MessageChat2Weeks(text, false)); // add the orignal message from server.
		}
		

	}
	void addNewMessage(MessageChat2Weeks m)
	{
		messages.add(m);
		adapter.notifyDataSetChanged();
		getListView().setSelection(messages.size()-1);
	}
}
