package com.example.chat2weeks;

import java.util.ArrayList;

import android.content.Intent;
import android.content.res.Resources;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
//import android.support.v4.app.FragmentTabHost;
import android.support.v4.app.FragmentTransaction;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ImageButton;
import android.widget.Spinner;
import android.widget.TabHost;
import android.widget.TextView;
import android.widget.Toast;

import com.example.chat2weeks.Model.SpinnerModel;
import com.example.chat2weeks.Others.DummyTabContent;
import com.example.chat2weeks.adapter.CustomAdapter;
import com.example.chat2weeks.tab.ChatListfragment;
import com.example.chat2weeks.tab.ContactFragment;
import com.example.chat2weeks.tab.ChatFragment;
import com.example.chat2weeks.tab.ContactFragment.ListFragmentClickListener;

/**
 * 5/11/2013
 * @author Normansyah Putra
 * link-untuk-mengerjakan ini : http://stackoverflow.com/questions/10407159/android-how-to-manage-start-activity-for-result
 */
public class DashboardActivity extends FragmentActivity implements ListFragmentClickListener  {// 
	public static final int CODE_DASBOARD_ACTIVITY = 1;
	public static final int PICK_IMAGE_DASHBOARD_ACTIVITY = 2;
	private Spinner spinnerStatus;
//	private FragmentTabHost mTabHost;
	private TabHost tHost;
	ArrayList<SpinnerModel> customStatusSpinner = new ArrayList<SpinnerModel>();
	CustomAdapter adapter;
	public static final String DEBUG_DASHBOARD_ACTIVITY = "com.example.chat2week.DashboardActivity";
	
	// TODO please convert RosterActivity to Fragment
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		Log.d(DEBUG_DASHBOARD_ACTIVITY, "Mulai constructor Dashboard Activity");
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_dashboard);
		
		// Menggunakan FragmentTabHost 
//		TabWidget tw = (TabWidget) findViewById(android.R.id.tabs);
//		LinearLayout ll = (LinearLayout) tw.getParent();
//		HorizontalScrollView hs = new HorizontalScrollView(this);
//		hs.setLayoutParams(new FrameLayout.LayoutParams(FrameLayout.LayoutParams.MATCH_PARENT, FrameLayout.LayoutParams.WRAP_CONTENT));
//		ll.addView(hs,0);
//		ll.removeView(tw);
//		hs.addView(tw);
//		hs.setHorizontalScrollBarEnabled(false);
//		
//		mTabHost = (FragmentTabHost) findViewById(android.R.id.tabhost);
//		mTabHost.setup(this, getSupportFragmentManager(), R.id.realtabcontent);
//		
//		Bundle b = new Bundle();
//		b.putString("TAB_ITEM_NAME", "Tab");
//		mTabHost.addTab(mTabHost.newTabSpec("roster").setIndicator("Roster"), RosterFragment.class, b);
//		mTabHost.addTab(mTabHost.newTabSpec("chatlist").setIndicator("Chat List"), ChatListfragment.class, b);
		
		// menggunakan TabHost dibawah ini
		tHost = (TabHost) findViewById(android.R.id.tabhost);
		tHost.setup();
		
		/** Defining Tab Change Listener event. This is invoked when tab is changed*/
		TabHost.OnTabChangeListener tabChangeListener = new TabHost.OnTabChangeListener() {
			@Override
			public void onTabChanged(String tabId) {
				FragmentManager fm = getSupportFragmentManager();
				ContactFragment contactFragment = (ContactFragment) fm.findFragmentByTag("contact");
				ChatFragment chatFragment = (ChatFragment) fm.findFragmentByTag("chat");
				FragmentTransaction ft = fm.beginTransaction();
				
				/* Detaches the androidfragment if exists*/
				if(contactFragment!=null)
					ft.detach(contactFragment);
				
				/** Detaches the appleFragment if exists*/
				if(chatFragment!=null){
					ft.detach(chatFragment);
				}
				
				/** if current tab is android*/
				if(tabId.equalsIgnoreCase("contact")){
					if(contactFragment==null){
						/** Create androidFragment and adding to fragmentTransactino*/
						ft.add(R.id.realtabcontent, new ContactFragment(), "contact");
					}else{
						/** Bring to the front, if already exists in the fragmentTransaction*/
						ft.attach(contactFragment);
					}
				}else{
					if(chatFragment==null){
						ft.add(R.id.realtabcontent, new ChatFragment(), "chat");
					}else{
						ft.attach(chatFragment);
					}
				}
				ft.commit();
			}// end of TabChangedMethod
		};
		
		/** Setting tabChangeListener for the tab*/
		tHost.setOnTabChangedListener(tabChangeListener);
		
		/** Defining tab builder for Android tab*/
		TabHost.TabSpec tSpecAndroid = tHost.newTabSpec("Contact");
		tSpecAndroid.setIndicator("Contact",getResources().getDrawable(R.drawable.contact));
		tSpecAndroid.setContent(new DummyTabContent(getBaseContext()));
		tHost.addTab(tSpecAndroid);
		
		/** Defining tab builder for Apple tab*/
		TabHost.TabSpec tSpecApple = tHost.newTabSpec("chat");
		tSpecApple.setIndicator("Chat List",getResources().getDrawable(R.drawable.chat));
		tSpecApple.setContent(new DummyTabContent(getBaseContext()));
		tHost.addTab(tSpecApple);
		
		// Spinner down here
		setDummyData();// isi customStatusSpinner
		
		Resources res = getResources();
		
		spinnerStatus = (Spinner) findViewById(R.id.spinner);
		adapter = new CustomAdapter(this, R.layout.status_layout, customStatusSpinner, res);
		spinnerStatus.setAdapter(adapter);
		
		spinnerStatus.setOnItemSelectedListener(
			new OnItemSelectedListener() {

				@Override
				public void onItemSelected(AdapterView<?> parent, View arg1,
						int arg2, long arg3) {
					if(arg1!=null){
						String status = ((TextView)arg1.findViewById(R.id.status_txt)).getText().toString();
						Toast.makeText(getApplicationContext(), "Selected status : \n\n"+status, Toast.LENGTH_SHORT).show();
						spinnerStatus.getSelectedItemPosition();
					}
				}

				@Override
				public void onNothingSelected(AdapterView<?> arg0) { }
			}
		);// end of spinner here
		
		/* initialize Image Button with onClick*/
		ImageButton imgButton = (ImageButton) findViewById(R.id.addButton);
		imgButton.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				Intent intent = new Intent(DashboardActivity.this, AddFriendActivity.class);
//				startActivity(intent);
				startActivityForResult(intent, CODE_DASBOARD_ACTIVITY);
			}
		});
		Log.d(DEBUG_DASHBOARD_ACTIVITY, "Selesai constructor Dashboard Activity");
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		if(requestCode==CODE_DASBOARD_ACTIVITY){
			if(resultCode==RESULT_OK){
				String result = data.getStringExtra(AddFriendActivity.RESULT_ADDFRIENDACTIVITY);
				Toast.makeText(getApplicationContext(), result, Toast.LENGTH_LONG).show();
			}else if(resultCode==RESULT_CANCELED){
				Toast.makeText(DashboardActivity.this, "Proses Pemilihan tidak jadi", Toast.LENGTH_LONG).show();
			}
		}// end of if
	}// end of onActivityResult method
	

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.dashboard, menu);
		return true;
	}
	
	/* default status */
	public static String[] status = {
			"available", "away", "offline"
	};
	
	/** set Dummy data here, default 3 dengan nama reddot1-3 */
	private void setDummyData(){
		for(int i=0;i<DashboardActivity.status.length;i++){
			final SpinnerModel sched = new SpinnerModel();
			sched.setStatusName(status[i]);
			sched.setImage("reddot"+i);
			customStatusSpinner.add(sched);
		}
	}
	
	public void pickImage(View view){
		Log.d(DEBUG_DASHBOARD_ACTIVITY, "mengubah profil gambar");
	}

	public static final String POSITION_LISTVIEW = "com.example.chat2week.DashboardActivity.ListView.positions";
	public static final String TYPE_FRAGMENT = "com.example.chat2week.DashboardActivity.TYPE_OF_FRAGMENT";
	/**
	 * http://wptrafficanalyzer.in/blog/itemclick-handler-for-listfragment-in-android/
	 * Masih error bagian ini, kalau diimplementasikan disini
	 * @author MSCI 
	 * Tanggal 7-11-2013
	 */
	@Override
	public void onListFragmentItemClick(int position) {
		// TODO disini harus membedakan antara yang mengklik 
		Intent intentWithoutName = new Intent(getApplicationContext(), ChatActivity.class);
		intentWithoutName.putExtra("position", position);
		startActivity(intentWithoutName);
	}

	@Override
	public void onListFragmentItemClick(int position, String name) {
		// TODO nanti bagian ini harus berupa objek disini, default dari contact
		String tempName = name;
		Intent nextIntent = new Intent(getApplicationContext(), ChatActivity.class);
		nextIntent.putExtra(ContactFragment.STRING_CONTACTFRAGMENT, tempName);
		nextIntent.putExtra(DashboardActivity.POSITION_LISTVIEW, position);
		startActivity(nextIntent);
	}

	@Override
	public void onListFragmentItemClick(int position, String name,
			int type_of_fragment) {
		String tempName = name;
		Intent nextIntent = null;
		switch (type_of_fragment) {
		case ContactFragment.TYPE_CONTACTFRAGMENT:
			nextIntent = new Intent(getApplicationContext(), ChatActivity.class);
			nextIntent.putExtra(ContactFragment.STRING_CONTACTFRAGMENT, tempName);
			nextIntent.putExtra(DashboardActivity.POSITION_LISTVIEW, position);
			nextIntent.putExtra(TYPE_FRAGMENT, type_of_fragment);
			startActivity(nextIntent);
			break;
		case ChatFragment.TYPE_CHATFRAGMENT:
			nextIntent = new Intent(getApplicationContext(), ChatActivity.class);
			nextIntent.putExtra(ChatFragment.STRING_CHATFRAGMENT, tempName);
			nextIntent.putExtra(DashboardActivity.POSITION_LISTVIEW, position);
			nextIntent.putExtra(TYPE_FRAGMENT, type_of_fragment);
			startActivity(nextIntent);
			break;
		case ChatListfragment.TYPE_CHATLISTFRAGMENT:
			// kosong
			break;
		default:
			Log.d(DEBUG_DASHBOARD_ACTIVITY, "Pesan tidak terkirim");
			break;
		}
		
	}

}
