package com.example.chat2weeks.adapter;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import android.app.Activity;
import android.content.Context;
import android.content.res.Resources;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.ImageView;
import android.widget.TextView;

import com.example.chat2weeks.R;
import com.example.chat2weeks.AsyncTask.ImageDownloaderTask;
import com.example.chat2weeks.Model.RosterModel;

public class AddFriendAdapter extends BaseAdapter {
	public static final String AddFriendAdapter_DEBUG = "com.example.chat2weeks.adapter.AddFriendAdapter";
	private Context mContext;
	private ArrayList<RosterModel> mRosterModels;
	private ArrayList<String> selectedStrings;

	public AddFriendAdapter(Context context, List<RosterModel> rosterModels) {
		mContext = context;
		mRosterModels = (ArrayList<RosterModel>) rosterModels;
		selectedStrings = new ArrayList<String>();
	}

	@Override
	public int getCount() {
		return mRosterModels.size();
	}

	/**
	 * Need to cast to RosterModel
	 */
	@Override
	public Object getItem(int arg0) {
		// TODO Auto-generated method stub
		return mRosterModels.get(arg0);
	}

	@Override
	public long getItemId(int position) {
		return mRosterModels.indexOf(getItem(position));
	}

	static class ViewHolder {
		protected ImageView imageView;
		protected CheckBox checkBox;
		protected TextView txtName;
	}

	public ArrayList<String> getResult() {
		if (selectedStrings.size() > 0) {
			return selectedStrings;
		} else {
			return new ArrayList<String>();
		}
	}

	/*
	 * Penjelasan mengenai setTag dan getTag :
	 * http://stackoverflow.com/questions
	 * /5291726/what-is-the-main-purpose-of-settag-gettag-methods-of-view Kalau
	 * mau mengganti data2 lakukan di Model atau Beannya. (non-Javadoc)
	 * 
	 * @see android.widget.Adapter#getView(int, android.view.View,
	 * android.view.ViewGroup)
	 */
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		ViewHolder holder = null;

		LayoutInflater mInflater = (LayoutInflater) mContext
				.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
		if (convertView == null) {
			convertView = mInflater.inflate(R.layout.row_add_friend, parent,
					false);
			holder = new ViewHolder();
			holder.imageView = (ImageView) convertView
					.findViewById(R.id.row_avaPic);
			holder.txtName = (TextView) convertView
					.findViewById(R.id.row_txtNama);
			holder.checkBox = (CheckBox) convertView
					.findViewById(R.id.row_chckBox);
			holder.checkBox
					.setOnCheckedChangeListener(new OnCheckedChangeListener() {

						@Override
						public void onCheckedChanged(CompoundButton buttonView,
								boolean isChecked) {
							int getPosition = (Integer) buttonView.getTag(); // Here
																				// we
																				// get
																				// the
																				// position
																				// that
																				// we
																				// have
																				// set
																				// for
																				// the
																				// checkbox
																				// using
																				// setTag.
							mRosterModels.get(getPosition).setChecked(
									buttonView.isChecked()); // Set the value of
																// checkbox to
																// maintain its
																// state.
							if (isChecked) {
								selectedStrings.add(mRosterModels.get(
										getPosition).getName());// "Posisi ke-"+getPosition
							} else {
								selectedStrings.remove(mRosterModels.get(
										getPosition).getName());// "Posisi ke-"+getPosition
							}
						}
					});
			convertView.setTag(holder);
			convertView.setTag(R.id.row_avaPic, holder.imageView);
			convertView.setTag(R.id.row_txtNama, holder.txtName);
			convertView.setTag(R.id.row_chckBox, holder.checkBox);
		} else {
			holder = (ViewHolder) convertView.getTag();
		}
		/* set background here */
		if ((int) position % 2 == 0) {
			convertView.setBackgroundResource(R.color.roster_genap);
		} else {
			convertView.setBackgroundResource(R.color.roster_ganjil);
		}

		holder.checkBox.setTag(position);// this line is important

		Resources res = convertView.getResources();

		// RosterModel rowItem = (RosterModel) mRosterModels.get(position);
		RosterModel rowItem = (RosterModel) getItem(position);

		holder.txtName.setText(rowItem.getName());
		/* set avapic here for using different image */
		if (holder.imageView != null) {
			// holder.imageView.setImageResource(res.getIdentifier(rowItem.getAvaPicPath(),
			// "drawable", mContext.getPackageName()));
			// Random random = new Random();
			// int randomPosition = 0+random.nextInt(getListData().size());//
			// ini nanti membuat gambar terus berganti
			// new
			// ImageDownloaderTask(holder.imageView).execute(getListData().get(randomPosition));
			new ImageDownloaderTask(holder.imageView).execute(rowItem
					.getAvaPicPath());
			// new
			// ImageDownloaderTask(holder.imageView).execute(getListData().get(rowItem.getId()));
		}
		holder.checkBox.setChecked(rowItem.isChecked());

		return convertView;
	}

	public static ArrayList<String> getListData() {
		ArrayList<String> results = new ArrayList<String>();
		// String newsData =
		// "http://lh5.ggpht.com/_hepKlJWopDg/TB-_WXikaYI/AAAAAAAAElI/715k4NvBM4w/s144-c/IMG_0075.JPG";
		// String newsData =
		// "http://upload.wikimedia.org/wikipedia/commons/1/17/MetroLigeroMad_logo_1.png";
		String newsData = "http://www.cavc.ac.uk/files/1013/1979/3689/level-1.png";
		results.add(newsData);

		// newsData =
		// "http://lh4.ggpht.com/_4f1e_yo-zMQ/TCe5h9yN-TI/AAAAAAAAXqs/8X2fIjtKjmw/s144-c/IMG_1786.JPG";
		// newsData =
		// "http://upload.wikimedia.org/wikipedia/commons/9/99/MetroLigeroMad_logo_2.png";
		newsData = "http://www.cavc.ac.uk/files/1713/1979/3690/level-2.png";
		results.add(newsData);

		// newsData =
		// "http://lh3.ggpht.com/_GEnSvSHk4iE/TDSfmyCfn0I/AAAAAAAAF8Y/cqmhEoxbwys/s144-c/_MG_3675.jpg";
		// newsData =
		// "http://upload.wikimedia.org/wikipedia/commons/2/21/MetroLigeroMad_logo_3.png";
		newsData = "http://thecripplegate.com/wp-content/uploads/2012/12/3.png";
		results.add(newsData);

		// newsData =
		// "http://lh6.ggpht.com/_ZN5zQnkI67I/TCFFZaJHDnI/AAAAAAAABVk/YoUbDQHJRdo/s144-c/P9250508.JPG";
		// newsData =
		// "http://upload.wikimedia.org/wikipedia/commons/thumb/2/28/MRT_Singapore_Destination_4.png/50px-MRT_Singapore_Destination_4.png";
		newsData = "http://www.cavc.ac.uk/files/1913/1979/3693/level-4.png";
		results.add(newsData);

		// newsData =
		// "http://lh4.ggpht.com/_XjNwVI0kmW8/TCOwNtzGheI/AAAAAAAAC84/SxFJhG7Scgo/s144-c/0014.jpg";
		// newsData =
		// "http://upload.wikimedia.org/wikipedia/commons/thumb/4/43/MRT_Singapore_Destination_5.png/50px-MRT_Singapore_Destination_5.png";
		newsData = "http://upload.wikimedia.org/wikipedia/en/3/3e/Bmt_triplex_no_5.png";
		results.add(newsData);

		// newsData =
		// "http://lh6.ggpht.com/_Nsxc889y6hY/TBp7jfx-cgI/AAAAAAAAHAg/Rr7jX44r2Gc/s144-c/IMGP9775a.jpg";
		newsData = "http://www.internetmarketingwebgraphics.com/images/6.png";
		results.add(newsData);

		// newsData =
		// "http://lh6.ggpht.com/_ZN5zQnkI67I/TCFFZaJHDnI/AAAAAAAABVk/YoUbDQHJRdo/s144-c/P9250508.JPG";
		// newsData =
		// "http://images4.wikia.nocookie.net/__cb20071027234504/uncyclopedia/images/a/a4/7-key.png";
		newsData = "https://lh5.googleusercontent.com/-3xayX68SXgs/Ujoj_3VzrMI/AAAAAAAAJt0/2lUeCXS7toI/s100/icon-ios7.png";
		results.add(newsData);

		// newsData =
		// "http://lh5.ggpht.com/_hepKlJWopDg/TB-_WXikaYI/AAAAAAAAElI/715k4NvBM4w/s144-c/IMG_0075.JPG";
		// newsData =
		// "http://upload.wikimedia.org/wikipedia/commons/d/d8/Logo_Small_Blue_House_(8).png";
		newsData = "http://upload.wikimedia.org/wikipedia/commons/3/31/Carter_8.png";
		results.add(newsData);

		newsData = "http://lh4.ggpht.com/_XjNwVI0kmW8/TCOwNtzGheI/AAAAAAAAC84/SxFJhG7Scgo/s144-c/0014.jpg";
		results.add(newsData);

		newsData = "http://lh6.ggpht.com/_Nsxc889y6hY/TBp7jfx-cgI/AAAAAAAAHAg/Rr7jX44r2Gc/s144-c/IMGP9775a.jpg";
		results.add(newsData);

		newsData = "http://lh6.ggpht.com/_ZN5zQnkI67I/TCFFZaJHDnI/AAAAAAAABVk/YoUbDQHJRdo/s144-c/P9250508.JPG";
		results.add(newsData);

		newsData = "http://lh5.ggpht.com/_hepKlJWopDg/TB-_WXikaYI/AAAAAAAAElI/715k4NvBM4w/s144-c/IMG_0075.JPG";
		results.add(newsData);

		newsData = "http://lh4.ggpht.com/_4f1e_yo-zMQ/TCe5h9yN-TI/AAAAAAAAXqs/8X2fIjtKjmw/s144-c/IMG_1786.JPG";
		results.add(newsData);

		newsData = "http://www.cavc.ac.uk/files/1713/1979/3690/level-2.png";
		results.add(newsData);

		newsData = "http://thecripplegate.com/wp-content/uploads/2012/12/3.png";
		results.add(newsData);

		newsData = "http://www.cavc.ac.uk/files/1913/1979/3693/level-4.png";
		results.add(newsData);

		newsData = "http://upload.wikimedia.org/wikipedia/en/3/3e/Bmt_triplex_no_5.png";
		results.add(newsData);

		newsData = "http://www.internetmarketingwebgraphics.com/images/6.png";
		results.add(newsData);

		newsData = "https://lh5.googleusercontent.com/-3xayX68SXgs/Ujoj_3VzrMI/AAAAAAAAJt0/2lUeCXS7toI/s100/icon-ios7.png";
		results.add(newsData);

		newsData = "http://upload.wikimedia.org/wikipedia/commons/3/31/Carter_8.png";
		results.add(newsData);

		return results;
	}

}
