package com.example.chat2weeks.adapter;

import java.util.ArrayList;

import com.example.chat2weeks.R;
import com.example.chat2weeks.Model.SpinnerModel;

import android.content.Context;
import android.content.res.Resources;
import android.support.v4.app.FragmentActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class CustomAdapter extends ArrayAdapter<SpinnerModel>{
	private FragmentActivity activity;
	private Context context;
	private ArrayList<SpinnerModel> data;
	public Resources res;
	SpinnerModel tempValues=null;
	LayoutInflater inflater;
	private LayoutInflater layoutInflater2;
	public static final String LOG_CUSTOM_ADAPTER = "com.example.chat2weeks.adapter.CustomAdapter";

	/**
	 * initialize the adapter, CustomAdapter Constructor
	 * @param activitySpinner try to use FragmentActivity
	 * @param textViewResourceId ??
	 * @param objects data 
	 * @param resLocal untuk mengambil gambar disini
	 */
	public CustomAdapter(Context context, int resource,
			ArrayList<SpinnerModel> objects, Resources resLocal){
		super(context,resource,objects);
		Log.d(LOG_CUSTOM_ADAPTER, "Masuk ke CustomAdapter Constructor");
		activity = (FragmentActivity) context;
		this.context = context;
		data = objects;
		res = resLocal;
		
		/** Layout inflater to call external xml layout*/
		inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
		Log.d(LOG_CUSTOM_ADAPTER, "Selesai CustomAdapter Constructor");
	}
	
	@Override
	public View getDropDownView(int position, View convertView, ViewGroup parent) {
		return getCustomView(position, convertView, parent);
	}
	
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		return getCustomView(position, convertView, parent);
	}
	
	public View getCustomView(int position, View convertView, ViewGroup parent)
	{
		Log.d(LOG_CUSTOM_ADAPTER, "Masuk ke getCustomView");
		View row = null;
		if(convertView == null){
			layoutInflater2 =  (LayoutInflater)context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			row = layoutInflater2.inflate(R.layout.status_layout, parent, false);
		}else{
			row = convertView;
		}
		tempValues = null;
		tempValues = (SpinnerModel) data.get(position);
		
		TextView status = (TextView) row.findViewById(R.id.status_txt);
		ImageView statusImg = (ImageView) row.findViewById(R.id.status_img);
		
//		if(position ==0){
//			status.setText(tempValues.getStatusName());
//		}
//		else{
			status.setText(tempValues.getStatusName());
			statusImg.setImageResource(res.getIdentifier(tempValues.getImage(), "drawable", getContext().getPackageName()));
//			statusImg.setImageResource(R.drawable.reddot);
//		}
		
		return row;
	}
}
