package com.example.chat2weeks.adapter;

import java.util.ArrayList;

import com.example.chat2weeks.R;
import com.example.chat2weeks.Model.MessageChat2Weeks;

import android.content.Context;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout.LayoutParams;
import android.widget.TextView;

public class MessageAdapter extends BaseAdapter {
	
	private ArrayList<MessageChat2Weeks> messages;
	private Context mContext;
	
	public MessageAdapter(Context Context, ArrayList<MessageChat2Weeks> messages){
		this.mContext = Context;
		this.messages = messages;
	}

	@Override
	public int getCount() {
		// TODO Auto-generated method stub
		return messages.size();
	}

	@Override
	public Object getItem(int arg0) {
		// TODO Auto-generated method stub
		return messages.get(arg0);
	}

	@Override
	public long getItemId(int arg0) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		MessageChat2Weeks message = (MessageChat2Weeks) this.getItem(position);
		
		ViewHolder holder;
		if(convertView == null)
		{
			holder = new ViewHolder();
			convertView = LayoutInflater.from(mContext).inflate(R.layout.row_chat_activity, parent, false);
			holder.message = (TextView) convertView.findViewById(R.id.message_text);
			convertView.setTag(holder);
		}
		else{
			holder = (ViewHolder) convertView.getTag();
		}
		
		holder.message.setText(message.getMessage());
		LayoutParams lp = (LayoutParams) holder.message.getLayoutParams();
		// Check apakah message dari diri sendiri 
		if(message.isMine())
		{
			holder.message.setBackgroundResource(R.drawable.speech_bubble_green);
			lp.gravity = Gravity.RIGHT;
		}
		else{
			holder.message.setBackgroundResource(R.drawable.speech_bubble_orange);
			lp.gravity = Gravity.LEFT;
		}
		holder.message.setLayoutParams(lp);
		holder.message.setTextColor(mContext.getResources().getColor(R.color.textColor));
		return convertView;
	}

	private static class ViewHolder
	{
		TextView message;
	}
	
	/**
	 * Class for dummy data
	 * @author MSCI
	 *
	 */
	public static class DummyData {
		public static final String [] sender= new String [] {"Lalit", "RobinHood", "Captain", "HotVerySpicy", "Dharmendra", "PareshMayani", "Abhi", "SpK", "CapDroid"};
		public static final String [] messages= new String [] {
			"Aah! thats cool",
			"Tu really CoLor 6e", 
			"Get Lost!!",
			"@AdilSoomro @AdilSoomro",
			"Lets see what the Rock is cooking..!!",
			"Yeah! thats great.",
			"Awesome Awesome!",
			"@RobinHood.",
			"Lalit ka Dillllll...!!!",
			"I'm fine, thanks, what about you?"};
		
	}
}


